#include <cstdio>
#include <cstdlib>
#include <vector>
#include <array>
 
extern void prepare_game(std::vector<int> A);
extern int play_game(int l, int r);
extern void update_game(int p, int v);
 
void my_assert(bool x) {
	if (!x) {
		puts("Wrong input");
		exit(0);
	}
}

int main(){
	int N, Q;
	my_assert(scanf("%d", &N) == 1);
	std::vector<int> A(N);
	for(int i=0; i<N; i++){
	    my_assert(scanf("%d", &A[i]) == 1);
	}
	prepare_game(A);
	my_assert(scanf("%d", &Q) == 1);
    while(Q--) {
    	int t; my_assert(scanf("%d", &t) == 1);
    	if(t == 1) {
    		int l, r; my_assert(scanf("%d%d", &l, &r) == 2);
    		printf("%d\n", play_game(l, r));
    	}
    	if(t == 2) {
    		int p, v; my_assert(scanf("%d%d", &p, &v) == 2);
    		update_game(p, v);
    	}
    }
}